/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the EstimationResult type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &EstimationResult{}

// EstimationResult struct for EstimationResult
type EstimationResult struct {
	Total int32 `json:"total"`
	TotalCostCents int32 `json:"total_cost_cents"`
}

// NewEstimationResult instantiates a new EstimationResult object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewEstimationResult(total int32, totalCostCents int32) *EstimationResult {
	this := EstimationResult{}
	this.Total = total
	this.TotalCostCents = totalCostCents
	return &this
}

// NewEstimationResultWithDefaults instantiates a new EstimationResult object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewEstimationResultWithDefaults() *EstimationResult {
	this := EstimationResult{}
	return &this
}

// GetTotal returns the Total field value
func (o *EstimationResult) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *EstimationResult) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *EstimationResult) SetTotal(v int32) {
	o.Total = v
}

// GetTotalCostCents returns the TotalCostCents field value
func (o *EstimationResult) GetTotalCostCents() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.TotalCostCents
}

// GetTotalCostCentsOk returns a tuple with the TotalCostCents field value
// and a boolean to check if the value has been set.
func (o *EstimationResult) GetTotalCostCentsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TotalCostCents, true
}

// SetTotalCostCents sets field value
func (o *EstimationResult) SetTotalCostCents(v int32) {
	o.TotalCostCents = v
}

func (o EstimationResult) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o EstimationResult) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["total"] = o.Total
	toSerialize["total_cost_cents"] = o.TotalCostCents
	return toSerialize, nil
}

type NullableEstimationResult struct {
	value *EstimationResult
	isSet bool
}

func (v NullableEstimationResult) Get() *EstimationResult {
	return v.value
}

func (v *NullableEstimationResult) Set(val *EstimationResult) {
	v.value = val
	v.isSet = true
}

func (v NullableEstimationResult) IsSet() bool {
	return v.isSet
}

func (v *NullableEstimationResult) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableEstimationResult(val *EstimationResult) *NullableEstimationResult {
	return &NullableEstimationResult{value: val, isSet: true}
}

func (v NullableEstimationResult) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableEstimationResult) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


